Subject: Re: [PATCH] difftool: support repositories with .git-files

From: Jens Lehmann <[email-masked]>
Date: Tue, 25 Feb 2014 20:34:30 +0000

Am 25.02.2014 18:02, schrieb Junio C Hamano:
> Jens Lehmann <[email-masked]> writes:
> 
>> Am 24.02.2014 17:55, schrieb Junio C Hamano:
>>> David Aguilar <[email-masked]> writes:
>>>
>>>> Modern versions of "git submodule" use .git-files to setup the
>>>> submodule directory.  When run in a "git submodule"-created
>>>> repository "git difftool --dir-diff" dies with the following
>>>> error:
>>>>
>>>> 	$ git difftool -d HEAD~
>>>> 	fatal: This operation must be run in a work tree
>>>> 	diff --raw --no-abbrev -z HEAD~: command returned error: 128
>>>>
>>>> core.worktree is relative to the .git directory but the logic
>>>> in find_worktree() does not account for it.
>>>>
>>>> Use `git rev-parse --show-toplevel` to find the worktree so that
>>>> the dir-diff feature works inside a submodule.
>>>>
>>>> Reported-by: Gábor Lipták <[email-masked]>
>>>> Helped-by: Jens Lehmann <[email-masked]>
>>>> Helped-by: John Keeping <[email-masked]>
>>>> Signed-off-by: David Aguilar <[email-masked]>
>>>> ---
>>>
>>> Looks good; thanks.
>>
>>
>> FWIW:
>> Tested-by: Jens Lehmann <[email-masked]>
>>
>> What about squashing this in to detect any future regressions?
>>
>> diff --git a/t/t7800-difftool.sh b/t/t7800-difftool.sh
>> index 2418528..d86ad68 100755
>> --- a/t/t7800-difftool.sh
>> +++ b/t/t7800-difftool.sh
>> @@ -434,4 +434,12 @@ test_expect_success PERL 'difftool --no-symlinks detects conflict ' '
>>  	)
>>  '
>>
>> +test_expect_success PERL 'difftool properly honours gitlink and core.worktree' '
>> +	git submodule add ./. submod/ule &&
>> +	(
>> +		cd submod/ule &&
>> +		git difftool --tool=echo  --dir-diff --cached
> 
> In the context of this fix, finishing with 0 exit status may be all
> we care about, but do we also care about things like in what
> directory the tool is invoked in, what arguments and extra
> environment settings (if any) it is given, and stuff like that?

Sure. But I just intended to test the fix (and the test can easily
be extended by people who know more about difftool than I do).

> In fact, the "echo" in the above is very misleading.  The test
> relies on the fact that immediately after the submod/ule is cloned,
> "diff --cached" does not have to call any tool backend---if you
> modify some tracked file in its working tree and dropped --cached
> on the command line, the command will fail with "Huh?  I do not know
> what 'echo' diff/merge backend is", no?

Right, using echo was not the best choice here. I used it to avoid
the dependency to meld in the example of the OP (maybe using "true"
as tool would have indicated that the tool is not important here,
but looking into this again a simple "git difftool --dir-diff"
without any further arguments also shows that the fix is working).

Aas mentioned above, I'm not familiar with difftool and just wanted
to share an easy way to test the fix. But I do not care too deeply
about this test, so feel free to ignore it.